SUBROUTINE panache(rg,temp,theta,rho,rhodz,klev,dz,thetath,Ftheta,flux,ent,det,vitw,d_t)

IMPLICIT NONE

REAL, dimension(klev) :: thetath, buoy,ent,det,temp,rho,rhodz,d_t,theta,dz

REAL, dimension(klev+1) :: flux,vitw,vitw2,Ftheta
REAL alpha, epsi,rg
INTEGER klev,k
LOGICAL actif

!useful computations


alpha=0.1
epsi=0
print*,'OK3'

!initialisation 


thetath(1)=theta(1)+(theta(1)-theta(2))/2
vitw(1)=0
vitw2(1)=0
flux(1)=0
det(1)=epsi
ent(1)=epsi
flux(2)=dz(1)*(ent(1)-det(1))
vitw(2)=flux(2)/alpha/rho(2)
Ftheta(1)=flux(1)*(thetath(1)-theta(1))
Ftheta(2)=flux(2)*(thetath(1)-theta(2))

!Boucle
print*,'OK4'

Ftheta(:)=0.
actif=.true.
do k=2,klev-1
       
        buoy(k)=rg*(thetath(k-1)-theta(k))/theta(k)
        vitw2(k+1)=vitw2(k)+dz(k)*alpha*buoy(k)
if (vitw2(k+1) > 0. .and. actif) then        
 vitw(k+1)=sqrt(vitw2(k+1))
        flux(k+1)=alpha*rho(k+1)*vitw(k+1)
        ent(k)=max((flux(k+1)-flux(k))/dz(k),0.)+epsi
        det(k)=max(-(flux(k+1)-flux(k))/dz(k),0.)+epsi
        thetath(k)=(dz(k)*ent(k)*theta(k)+flux(k)*thetath(k-1))/(flux(k+1)+det(k)*dz(k)) 
 
        Ftheta(k+1)=flux(k+1)*(thetath(k)-theta(k+1)) 
else
actif=.false.
vitw(k+1)=0
thetath(k)=theta(k)
ent(k)=0.
det(k)=0.
flux(k+1)=0.
endif
enddo

ent(klev)=0. ; det(klev)=0. ; flux(klev+1)=0.

print*,'OK5'


do k=1,klev
d_t(k)=d_t(k)+(Ftheta(k)-Ftheta(k+1))/(rhodz(k))*temp(k)/theta(k)
enddo
Ftheta(1)=0. ; Ftheta(klev+1)=0.

end subroutine panache
