! $Id: .F 1565 2011-08-31 12:53:29Z jghattas $
!#define IO_DEBUG

      SUBROUTINE nuages(klev,dz,phi,theta,ovap,qsat,vitw,kappaz,frac_nuag)

      USE ioipsl , ONLY : getin

      IMPLICIT NONE
#include "YOMCST.h"


!--------------------------------------------------------------------
! Delcarations
!--------------------------------------------------------------------
! Arguments
INTEGER :: klev
REAL, DIMENSION(klev) :: theta,ovap,dz,phi,qsat,frac_nuag
REAL, DIMENSION(klev+1) :: vitw, kappaz

! Local
INTEGER :: k
REAL, DIMENSION(klev) :: rapp
REAL, SAVE :: lkap=10., rapp0_nuage=0.2
INTEGER, SAVE ::  choix_nuage=1
LOGICAL, SAVE :: first=.true.

!--------------------------------------------------------------------
! Initialisations
!--------------------------------------------------------------------
if (first) then
   CALL getin('lkap',lkap)
   CALL getin('rapp0_nuage',rapp0_nuage)
   CALL getin('choix_nuage',choix_nuage)
   first=.false.
endif

!--------------------------------------------------------------------
! 1/ Vertical velocity
!--------------------------------------------------------------------
vitw(:)=0.
do k=2,klev
   vitw(k)=vitw(k-1)**2+2*rg*dz(k)*(theta(1)-theta(k))/theta(k)
   if (vitw(k)<0) then
      vitw(k)=0
      exit
   endif
   vitw(k)=sqrt(vitw(k))
enddo
do k=1,klev
   kappaz(k)=lkap*max(vitw(k),0.001*(max(1000-phi(k)/RG,0.)))
enddo
kappaz(klev+1)=0.
! On met une valeur minimum de kz
kappaz(2)=kappaz(3)/2.

!--------------------------------------------------------------------
! 2/ Clouds
!--------------------------------------------------------------------
if (choix_nuage==0) then
   rapp(:)=rapp0_nuage
elseif (choix_nuage==1) then
   do k=1,klev
      rapp(k)=rapp0_nuage*phi(k)/rg/1000.
   enddo
elseif (choix_nuage==2) then
   do k=1,klev
      rapp(k)=rapp0_nuage*abs(ovap(1)-ovap(k))/ovap(k)
   enddo
endif
do k=1,klev
   if (qsat(k)<ovap(k)*(1-rapp(k)/2)) then
      frac_nuag(k)=1
   elseif (qsat(k)>ovap(k)*(1+rapp(k)/2)) then
      frac_nuag(k)=0
   else
      frac_nuag(k)=(ovap(k)+0.5*rapp(k)*ovap(k)-qsat(k))/(rapp(k)*ovap(k))
   endif
enddo


      return
      end

